// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#include <iostream>
#include "call.hpp"

// TODO, using a stl::list for call-ids is not a good solution
list<Call*> Call::s_CallList;

Call::Call(Server* a_Server, Client* a_Client) :
    m_CallState(CALL_IDLE),
    m_ServerID(0),
    m_ClientID(0),
    m_ProxyID(0)
{
    m_Server = a_Server;
    m_Client = a_Client;
    m_ServerAddr = a_Server->m_SockAddr4;
    m_ClientAddr = a_Client->m_SockAddr4;
    m_SpoofAddr = a_Client->m_TargetAddr4;

    // FIXME: The call-id MUST be unique, checks must be implemented
    // to verify that no other call has the same call-id
    m_ProxyID = (random() & 0xffff);

    s_CallList.push_back(this);
}

Call::~Call()
{
    s_CallList.erase(find(s_CallList.begin(), s_CallList.end(), this));
}

bool Call::operator==(u_int16_t a_ID)
{
    return (a_ID == m_ProxyID);
}
