// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#ifndef __CALL_HPP
#define __CALL_HPP

#include <list>
#include "server.hpp"
#include "client.hpp"

using std::list;

enum call_state_t {CALL_IDLE = 0, CALL_WAITREPLY, CALL_ESTABLISHED, CALL_WAITDISCONNECT};

class Call
{
    friend int main(int, char**);
    friend class Session;
    public:
	Call(Server* a_Server, Client* a_Client);
	~Call();

	static list<Call*> callList() { return s_CallList; };

	struct sockaddr_in m_ServerAddr;
	struct sockaddr_in m_ClientAddr;
	struct sockaddr_in m_SpoofAddr;
	u_int16_t serverID() { return m_ServerID; };
	u_int16_t clientID() { return m_ClientID; };

	bool operator==(u_int16_t a_ID);

    private:
	call_state_t m_CallState;

	u_int16_t m_ServerID;
	u_int16_t m_ClientID;
	u_int16_t m_ProxyID;

	Server* m_Server;
	Client* m_Client;

	static list<Call*> s_CallList;
};

#endif
