// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#include <unistd.h>
#include <errno.h>

#include "client.hpp"
#include "session.hpp"
#include "util.hpp"

int Client::m_NumClients = 0;

Client::Client(const int a_Socket, const struct sockaddr_in a_SockAddr4, struct sockaddr_in a_ServerAddr4, const struct sockaddr_in a_TargetAddr4)
    throw(MemoryException) :
	Entity(a_Socket),
	m_CtrlState(CLIENT_IDLE)
{
    m_SockAddr4 = a_SockAddr4;
    m_TargetAddr4 = a_TargetAddr4;
    m_ServerAddr4 = a_ServerAddr4;

    m_UpdateDate = m_ConnectDate;
    m_NumClients++;
    DEBUGF(("Client::Client = %p\n", this));
}

Client::~Client()
{
    if (m_Socket) close(m_Socket);
    m_NumClients--;
    DEBUGF(("Client::~Client = %p\n", this));
}

int Client::process()
{
    int ret = -1;
    if (this->read() > 0) ret = m_Session->process(this);
    return ret;
}

Session* Client::detatch()
{
    m_Session->detatch(this);
    return NULL;
}
