// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#ifndef __CLIENT_HPP
#define __CLIENT_HPP

#include "entity.hpp"
#include "exception.hpp"

enum client_state_t {CLIENT_IDLE = 0, CLIENT_WAITCTRLREPLY, CLIENT_ESTABLISHED, CLIENT_WAITSTOPREPLY};

class Client: public Entity
{
    friend class Session;
    public:
	Client(const int a_Socket, struct sockaddr_in a_SockAddr4, struct sockaddr_in a_ServerAddr4, struct sockaddr_in a_TargetAddr4)
	    throw(MemoryException);
	~Client();

	int process();
	Session* detatch();

	struct sockaddr_in server() { return m_ServerAddr4; };

    private:
	void cleanup();

	static int m_NumClients;
	client_state_t m_CtrlState;
};

#endif
