// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#ifndef __LISTENER_HPP
#define __LISTENER_HPP

#include <netinet/in.h>

#include "exception.hpp"

class Listener
{
    public:
	Listener(const char* a_Address, const int a_Port)
	    throw(NetworkException);
	~Listener();

	int accept();

	void setName(const char* a_Name) { m_Name = a_Name; };
	void setHost(const char* a_Host) { m_Host = a_Host; };
	void setVendor(const char* a_Vendor) { m_Vendor = a_Vendor; };
	void setTarget(const char* a_Address, const int a_Port);

	const char* address() { return m_Address; };
	const int port() { return m_Port; };
	const char* name() { return m_Name; };
	const char* host() { return m_Host; };
	const char* vendor() { return m_Vendor; };

	const int m_Socket;

    private:
	struct sockaddr_in m_SockAddr4;
	struct sockaddr_in6 m_SockAddr6;

	const char* m_Address;
	const int m_Port;

	const char* m_Name;
	const char* m_Host;
	const char* m_Vendor;
	struct {
	    const char*	address;
	    int	port;
	    struct sockaddr_in sockAddr4;
	    struct sockaddr_in sockAddr6;
	} m_Target;
};

#endif
