// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#ifndef LOGGER_HPP
#define LOGGER_HPP
#include <syslog.h>
#include <errno.h>

#include "exception.hpp"

#define LOGGER_SYSLOG 1
#define LOGGER_STDOUT 2
#define LOGGER_DEBUG 4
class Logger;
class Logger
{
   public:
	Logger(const char* a_Identity, unsigned int a_Facility, unsigned int a_Flags)
	   throw(GeneralException);
	~Logger();
	void log(unsigned int a_Level, char* a_Format, ...);

	static Logger* getLogger() { return s_Logger; };

   private:
	static Logger* s_Logger;
	unsigned int m_Flags;
};

#endif
