// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#include <unistd.h>
#include <strings.h>
#include <arpa/inet.h>
#include <errno.h>

#include "server.hpp"
#include "session.hpp"
#include "util.hpp"

int Server::m_NumServers = 0;

Server::Server(const struct sockaddr_in a_ServerAddr4)
    throw(MemoryException, NetworkException) :
	Entity(0),
	m_CtrlState(SERVER_IDLE)
{
    m_SockAddr4 = a_ServerAddr4;
    m_UpdateDate = m_ConnectDate;
    m_NumServers++;
    DEBUGF(("Server::Server = %p\n", this));
}

Server::~Server()
{
    if (m_Socket) close(m_Socket);
    m_NumServers--;
    DEBUGF(("Server::~Server = %p\n", this));
}

void Server::connect()
    throw(NetworkException)
{
    int* socket = const_cast<int*>(&m_Socket);
    
    if (0 > (*socket = getSocket(SOCK_STREAM, IPPROTO_IP))) throw NetworkException(errno);
    if (-1 == ::connect(*socket, reinterpret_cast<struct sockaddr*>(&m_SockAddr4), sizeof(m_SockAddr4)))
    {
	close(m_Socket);
	*socket = 0;
	throw NetworkException(errno);
    }
}

int Server::process()
{
    int ret = -1;
    if (this->read() > 0) ret = m_Session->process(this);
    return ret;
}

Session* Server::detatch()
{
    Session* tmpSession = m_Session;

    delete m_Session;
    m_Session = NULL;

    return tmpSession;
}
