// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#include "timer.hpp"

std::list<Timer*> s_TimerList;

Timer::Timer(int a_Time, pthread_t a_Owner, int a_Signal)
{
    struct timeval tempTime;

    gettimeofday(&tempTime, NULL);
    tempTime.tv_sec += a_Time;
}

Timer::~Timer()
{
    if (m_Owner) pthread_kill(m_Owner, m_Signal);
}

Timer* NewTimer(int a_Time, pthread_t* a_Owner, int a_Sig)
{
    Timer* newTimer = new Timer(a_Time, a_Owner. a_Sig);
    if (g_TimerList.emtpy())
    {
	struct itimerval tempTimer;

	tempTimer.it_interval = 0;
	tempTimer.it_value = a_Time;
	setitimer(ITIMER_REAL, &tempTimer, NULL);
    }
    s_TimerList.pushback(newTimer);
}


