// Frickin PPTP Proxy, Copyright (c) 2004-06 Martin Akesson <@placid.tv>
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <pwd.h>
#include <grp.h>

#include "util.hpp"

void dropPrivileges(const char* a_User, const char* a_Group)
    throw(PrivdropException)
{
    int ret = 0;
    struct passwd* pwd = getpwnam(a_User);
    struct group* grp = getgrnam(a_Group);

    endpwent();
    endgrent();
    if (grp && pwd)
    {
	ret = setgid(grp->gr_gid);
	if (!ret) ret = setuid(pwd->pw_uid);
    } else ret = -1;

    if (ret) throw(PrivdropException(a_User, a_Group));
}

int getSocket(int a_Type, int a_Proto)
{
    int s;

    if (-1 != (s = socket(AF_INET, a_Type, a_Proto)))
    {
	int flags = 1;
	if (a_Proto == IPPROTO_IP)
	{
#ifdef SO_REUSEPORT
	    setsockopt(s, SOL_SOCKET, SO_REUSEPORT, static_cast<void*>(&flags), sizeof(flags));
#endif
	    setsockopt(s, SOL_SOCKET, SO_REUSEADDR, static_cast<void*>(&flags), sizeof(flags));
	}
    }

    return s;
}
